#!/usr/bin/perl -w
use strict;
use Fcntl ':flock';

BEGIN {
use FindBin;
require $FindBin::Bin.'/env.pl';
};

require "stats_parse.pm";
require "crypt.pm";
use sdep;

my $sleeptime = 20;
my $daemon_log = $env::Private_base.$env::Path_Delim.'daemon.log';
my $stop_daemon = $env::stop_daemon;

&demon_main;

sub demon_main
{
    close (STDOUT);
    close (STDIN);
    close (STDERR);

    open (STDOUT, "> $daemon_log");
           print " Daemon start \;\n";
    open (STDERR, '>& STDOUT');
    chmod $env::File_mode, $daemon_log;
#    select (FDL);
#

    open (FD, "+> $env::recrypt_lock") or return "";
    if (!flock (FD, LOCK_EX| LOCK_NB)) {
        print " Daemon : File recrypt_lock already Lockted; exit \n";
        close(FD);
        exit;
    }

    open (FD2, "+> $env::recrypt_lock2") or return "";
    flock (FD2, LOCK_EX);

for (; ! -f $stop_daemon ;) {
    time_to_reset();
    crypt::recrypt_all_packages();
    sleep($sleeptime);
}

    close (FD);
    close (FD2);
           print " Daemon end \;\n";
    close (STDOUT);
    close (STDERR);
    return "ok";
}
