package my_subs;

use strict;
use XML::DOM;
require "env.pl";
require "Package_DB.pm";

my $parser = new XML::DOM::Parser;
my $dir = $env::Package_base;

$my_subs::odd = "odd";
$my_subs::error = 0;
return "OK";

sub is_period
{
  my $period = $_[0];
  my $last = chop ($period);

  if ($last eq "m" || $last eq "h" || $last eq "d") {
    $my_subs::error = 0
  }
  else {
    $my_subs::error = 1
  };

  if (($period != 0) and ($period =~ /[0-9]+/)) {
    $my_subs::error = 0
  }
  else {
    $my_subs::error = 1
  };
}

sub is_href
{
  my $href = $_[0];

  $my_subs::error = 0
}

sub del
{
  my $fileName = $_[0];
  my $path = $env::Package_base.$env::Path_Delim.$fileName.$env::extension;
  my $res = unlink ($path);
  Package_DB::package_delete ($fileName);
  $path = $env::Public_base.$env::Path_Delim.'packages'.$env::Path_Delim.$fileName.$env::extension_crypt;
  #print "Deleting: $path<br>\n";
  if ( -f $path ) { unlink $path; }
}

# update Package_DB
sub update_db
{
  my $package = $_[0];
  if ($package) {
	my $path = $env::Package_base.$env::Path_Delim.$package.$env::extension;
	my $doc = $parser->parsefile ($path);
	if ($doc) {
		my @refs;
		my $lifetime;

		my $nodes = $doc->getElementsByTagName ("referer");
        	my $n = $nodes->getLength;
		my $attr;

        	for (my $i = 0; $i < $n; $i++)
	        {
        	    my $node = $nodes->item ($i);
	            $attr = $node->getAttributeNode ("href");
		    if ($attr) {
			    $refs[++$#refs] = $attr->getValue;
		    }
	        }

		$nodes = $doc->getElementsByTagName ("rescramble");
        	$n = $nodes->getLength;
		if ($n > 0)
	        {
	            $attr = ($nodes->item(0))->getAttributeNode ("period");
		    if ($attr) {
			    $lifetime = $attr->getValue;
		    }
	        }

		$doc->dispose;
		Package_DB::package_change($package, $lifetime, @refs);
	}
  }
}

sub even
{
my $l = $_[0];
   if ($l eq "odd") {
      $my_subs::odd = "even";
   }
   else {
      $my_subs::odd = "odd";
   }
}

sub edit_dom {

my $fileName = $_[0];
#my $path = $dir.$fileName.$extension;
my $path = $env::Package_base.$env::Path_Delim.$fileName.$env::extension;

print <<HTML;

<div align="center">
<form method="POST" action="submit_dom.pl"  enctype="multipart/form-data">
<input type="hidden" value="$fileName" name="fileName">
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<tr><td align=center colspan=3 class="hd">

HTML

print "Edit " . $fileName . "</td></tr>\n";
print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";
#my $parser = new XML::DOM::Parser;

unless (eval {

 my $doc = $parser->parsefile ($path);
 my $pac = $doc->getElementsByTagName ("package");
 my $lPac = $pac->getLength;

 my $countAttr = 0;
 my $tagItemList;
 my $node;
 my $nodeChield;
 my $len;
 my $lenChield;
 my $data;
 my $attrList;
 my $lenAttr;
 my $attrValue;
 my $attrName;
 my $i;
 my $j;
 my %needAttr;
 my %attrValue;
 my $findAttr;
 my $first;
 my $parent;
 my $par;

 print "<tr><td align=center class='subhd'>Parameter</td><td align=center class=subhd>Parameter Value</td><td align=center class=subhd>Delete Selected on Save</td></tr>\n";

# $odd="odd";
 if ($lPac != 0) {
    $node = $doc->getElementsByTagName ("title");
    $len = $node->getLength;
    $first = 1;

    print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Title: </td><td class=$my_subs::odd>\n";
    even ($my_subs::odd);

    for ($i = 0; $i < $len; $i++) {
       $parent = $node->item($i)->getParentNode;

       if ($parent == $pac->item(0)) {

          if ($first) {
             $nodeChield = $node->item($i)->getChildNodes;
             $lenChield = $nodeChield->getLength;

             for ($j = 0; $j < $lenChield; $j++) {
                if ($nodeChield->item($j)->getNodeType == TEXT_NODE) {
                   $first = 0;
                   $data = $nodeChield->item($j)->getData;
                   $data =~ s/\'/&#039;/g;
                   $data =~ s/\"/&quot;/g;
                   print "<input type=text name='title" . $i . "' size=40 value='" . $data . "'>\n";
                }
             };
             if ($first) {
                $first = 0;
                print "<input type=text name='title" . $i . "' size=40 value=''>\n";
             };
          }
       }
    };
    if ($first) {
       print "<input type=text name='title" . $i . "' size=40 value=''>\n";
    };
    print "</td><td class=$my_subs::odd>&nbsp;</td></tr>\n";

print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";


#########################################
#
# always look only first <protection>
# if there are next <protection>s, having needed tags, we don't look its
#
#########################################

    $par = $doc->getElementsByTagName ("protection");
    $len = $par->getLength;
    if ($len != 0) {

       $node = $doc->getElementsByTagName ("referer");
       $len = $node->getLength;
       $first = 1;

       for ($i = 0; $i < $len; $i++)
       {
          $parent = $node->item($i)->getParentNode;

          if ($parent == $par->item(0)) {
             $first = 0;
             $attrList = $node->item($i)->getAttributes->getValues;
             $lenAttr = $attrList->getLength;

             $findAttr = 0;
             for ($j = 0; $j < $lenAttr; $j++) {
                if ($attrList->item($j)->getName eq 'href') {
                   $findAttr = 1;
                   $attrValue = $attrList->item($j)->getValue;
                   $attrValue =~ s/\'/&#039;/g;
                   $attrValue =~ s/\"/&quot;/g;
                   print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Referer: </td><td class=$my_subs::odd><input type=text name='referer_href" . $i . "' size=40 value='" . $attrValue . "'></td>\n";
                   print "<td class=$my_subs::odd align='center'><input type='checkbox' name='referer_href_del". $i .
                         "' value='del'></td></tr>\n";
                   even ($my_subs::odd);
                }
             };
                if (!$findAttr) {
                   print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Referer: </td><td class=$my_subs::odd><input type=text name='referer_href" . $i . "' size=40 value=''></td>\n";
                   print "<td class=$my_subs::odd align='center'><input type='checkbox' name='referer_href_del". $i .
                         "' value='del'></td></tr>\n";
                   even ($my_subs::odd);
                }
          }
       };

#       if ($first) {
#          print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Referer: </td><td class=$my_subs::odd colspan=2><input type=text name='referer_href" . $i . "' size=40 value=''></td></tr>\n";
#          even ($my_subs::odd);
#       };

       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Add new referer: </td><td class=$my_subs::odd colspan=2><input type=text name='new_referer_href' size=40 value=''></td></tr>\n";

       print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";

       $node = $doc->getElementsByTagName ("lifetime");
       $len = $node->getLength;
       $first = 1;

       even ($my_subs::odd);
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Lifetime: </td><td colspan=2 class=$my_subs::odd>\n";

       for ($i = 0; $i < $len; $i++) {
          $parent = $node->item($i)->getParentNode;

          if ($parent == $par->item(0)) {
             if ($first) {
                $first = 0;
                $attrList = $node->item($i)->getAttributes->getValues;
                $lenAttr = $attrList->getLength;

                $findAttr = 0;
                for ($j = 0; $j < $lenAttr; $j++) {

                   if ($attrList->item($j)->getName eq 'period') {
                      $findAttr = 1;
                      $attrValue = $attrList->item($j)->getValue;
                      $attrValue =~ s/\'/&#039;/g;
                      $attrValue =~ s/\"/&quot;/g;

                      print "<input type=text name='lifetime_period" .$i. "' size=40 value='" . $attrValue . "'>\n";
                   }
                };
                if (!$findAttr) {
                   print "<input type=text name='lifetime_period" .$i. "' size=40 value=''>\n";
                }
             }
          }
       };
       if ($first) {
          print "<input type=text name='lifetime_period" .$i. "' size=40 value=''>\n";
       };
       print "</td></tr>\n";

print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";

       $node = $doc->getElementsByTagName ("rescramble");
       $len = $node->getLength;
       $first = 1;

       even ($my_subs::odd);
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Rescramble period: </td><td colspan=2 class=$my_subs::odd>\n";

       for ($i = 0; $i < $len; $i++) {
          $parent = $node->item($i)->getParentNode;

          if ($parent == $par->item(0)) {
             if ($first) {
                $first = 0;
                $attrList = $node->item($i)->getAttributes->getValues;
                $lenAttr = $attrList->getLength;

                $findAttr = 0;
                for ($j = 0; $j < $lenAttr; $j++) {

                   if ($attrList->item($j)->getName eq 'period') {
                      $findAttr = 1;
                      $attrValue = $attrList->item($j)->getValue;
                      $attrValue =~ s/\'/&#039;/g;
                      $attrValue =~ s/\"/&quot;/g;
                      print "<input type=text name='rescramble_period" .$i. "' size=40 value='" . $attrValue . "'>\n";
                   }
                };
                if (!$findAttr) {
                   print "<input type=text name='rescramble_period" .$i. "' size=40 value=''>\n";
                }
             }
          }
       };
       if ($first) {
          print "<input type=text name='rescramble_period" .$i. "' size=40 value=''>\n";
       };
       print "</td></tr>\n";
       print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";

    }
    else {

       $node = $doc->getElementsByTagName ("referer");
       $len = $node->getLength;
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Referer: </td><td colspan=2 class=$my_subs::odd><input type=text name='referer_href" . $len . "' size=40 value=''></td></tr>\n";

       $node = $doc->getElementsByTagName ("lifetime");
       $len = $node->getLength;
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Lifetime: </td><td colspan=2 class=$my_subs::odd><input type=text name='lifetime_period" .$len. "' size=40 value=''></td></tr>\n";

       $node = $doc->getElementsByTagName ("rescramble");
       $len = $node->getLength;
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Rescramble period: </td><td colspan=2 class=$my_subs::odd><input type=text name='rescramble_period" .$len. "' size=40 value=''></td></tr>\n";

       print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";
    };

#########################################
#
# always look only first <stat>
# if there are next <stat>s, having needed tags, we don't look its
#
#########################################

    $par = $doc->getElementsByTagName ("stat");
    $len = $par->getLength;

    even ($my_subs::odd);
    print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Report download to: </td><td colspan=2 class=$my_subs::odd>\n";

    if ($len != 0) {

       $node = $doc->getElementsByTagName ("report");
       $len = $node->getLength;
       $first = 1;

       for ($i = 0; $i < $len; $i++)
       {
          $parent = $node->item($i)->getParentNode;

          if ($parent == $par->item(0)) {

             if ($first) {
                $first = 0;
                $attrList = $node->item($i)->getAttributes->getValues;
                $lenAttr = $attrList->getLength;
                $findAttr = 0;

                for ($j = 0; $j < $lenAttr; $j++) {

                   if ($attrList->item($j)->getName eq 'href') {
                      $findAttr = 1;
                      $attrValue = $attrList->item(0)->getValue;
                      $attrValue =~ s/\'/&#039;/g;
                      $attrValue =~ s/\"/&quot;/g;
                      print "<input type=text name='report_href" .$i. "' size=40 value='" . $attrValue . "'>\n";
                   }
                };
                if (!$findAttr) {
                   print "<input type=text name='report_href" . $i . "' size=40 value=''>\n";
                }
             }
          }
       };

       if ($first) {
          $i--;
          print "<input type=text name='report_href" .$i. "' size=40 value=''>\n";
       }
    }
    else {
       $node = $doc->getElementsByTagName ("report");
       $len = $node->getLength;
       print "<input type=text name='report_href" .$len. "' size=40 value=''>\n";
    };

    print "</td></tr>\n";
print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";

#########################################
#
# Download template parameter,
# which is not placed into package itself
# but stored in the file near
#
#########################################

even ($my_subs::odd);
print <<HTML;
<tr>
<td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Download template: </td>
<td class=$my_subs::odd><input type=file name='template_file' size=28></td>
HTML

if ( -f $dir.$env::Path_Delim.$fileName.$env::extension_html ) { print <<HTML;
<td class=$my_subs::odd align='center'><input type='checkbox' name='template_file_del' value='del'><br>
<small>(revert to default)</small>
</td>
HTML
} else { print <<HTML;
<td class=$my_subs::odd align='center'>Default</td>
HTML
}

print <<HTML;
</tr>
<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>
HTML

#########################################
#
# always look only first <content>
# if there are next <content>s, having needed tags, we don't look its
#
#########################################

    $par = $doc->getElementsByTagName ("content");
    $len = $par->getLength;
    if ($len != 0) {

       $node = $doc->getElementsByTagName ("base");
       $len = $node->getLength;
       $first = 1;

       even ($my_subs::odd);
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Download source base: </td><td colspan=2 class=$my_subs::odd>\n";

       for ($i = 0; $i < $len; $i++)
       {
          $parent = $node->item($i)->getParentNode;

          if ($parent == $par->item(0)) {
             if ($first) {
                $first = 0;
                $attrList = $node->item(0)->getAttributes->getValues;
                $lenAttr = $attrList->getLength;

                $findAttr = 0;
                for ($j = 0; $j < $lenAttr; $j++) {

                   if ($attrList->item($j)->getName eq 'href') {
                      $findAttr = 1;
                      $attrValue = $attrList->item($j)->getValue;
                      $attrValue = $attrList->item(0)->getValue;
                      $attrValue =~ s/\'/&#039;/g;
                      $attrValue =~ s/\"/&quot;/g;
                      print "<input type=text name='base_href" .$i. "' size=40 value='" . $attrValue . "'>\n";
                      even ($my_subs::odd);
                   }
                };
                if (!$findAttr) {
                   print "<input type=text name='base_href" .$i. "' size=40 value=''>\n";
                   even ($my_subs::odd);
                }
             }
          }
       };
       if ($first) {
          print "<input type=text name='base_href" .$i. "' size=40 value=''>\n";
          even ($my_subs::odd);
       };
       print "</td></tr>\n";

    $node = $doc->getElementsByTagName ("file");
    $len = $node->getLength;
    $first = 1;

    for ($i = 0; $i < $len; $i++)
    {
       $needAttr {"title"} = 0;
       $needAttr {"href"} = 0;
       $needAttr {"rename"} = 0;

       $parent = $node->item($i)->getParentNode;

       if ($parent == $par->item(0)) {
print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";
print "<tr><td colspan=2 class='subhd2' align=center>File</td>\n";
print "<td class='subhd2' align='center'><input type='checkbox' name='file_del". $i .
                "' value='del'></td></tr>\n";
         $first = 0;
         $attrList = $node->item($i)->getAttributes->getValues;
         $lenAttr = $attrList->getLength;

          for ($j = 0; $j < $lenAttr; $j++)
          {
             $attrList = $node->item($i)->getAttributes->getValues;
             $attrName = $attrList->item($j)->getName;
             $attrValue {$attrName} = $attrList->item($j)->getValue;
             $needAttr {$attrName} = 1;
             $attrValue {$attrName} =~ s/\'/&#039;/g;
             $attrValue {$attrName} =~ s/\"/&quot;/g;
          };

          print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Title: </td><td colspan=2 class=$my_subs::odd>\n";
          if ($needAttr {"title"}) {
             print "<input type=text name='file_title" . $i ."' size=40 value='".$attrValue {'title'}."'>\n";
          }
          else {
             print "<input type=text name='file_title" . $i ."' size=40 value=''>\n";
          };
          even ($my_subs::odd);
          print "</td></tr>\n";

          print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Href: </td><td colspan=2 class=$my_subs::odd>\n";
          if ($needAttr {"href"}) {
             print "<input type=text name='file_href" . $i ."' size=40 value='".$attrValue {'href'}."'>\n";
          }
          else {
             print "<input type=text name='file_href" . $i ."' size=40 value=''>\n";
          };
          print "</td></tr>\n";
          even ($my_subs::odd);

          print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Rename: </td><td colspan=2 class=$my_subs::odd>\n";
          if ($needAttr {"rename"}) {
             print "<input type=text name='file_rename" . $i ."' size=40 value='".$attrValue {'rename'}."'>\n";
          }
          else {
             print "<input type=text name='file_rename" . $i ."' size=40 value=''>\n";
          };
          print "</td></tr>\n";
          even ($my_subs::odd);

       };
    };

    for ( $i = 0; $i < 5; $i++ ) {
        print "<tr><td colspan=3 height=1 class='line'><img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>\n";
        print "<tr><td colspan=3 class='subhd2' align=center>Add New File</td>\n";
        print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Title: </td><td colspan=2 class=$my_subs::odd><input type=text name='new_file_title$i' size=40 value=''></td></tr>\n";
        even ($my_subs::odd);

        print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Href: </td><td colspan=2 class=$my_subs::odd><input type=text name='new_file_href$i' size=40 value=''></td></tr>\n";
        even ($my_subs::odd);

        print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Rename: </td><td colspan=2 class=$my_subs::odd><input type=text name='new_file_rename$i' size=40 value=''></td></tr>\n";
        even ($my_subs::odd);
    }

    }
    else {
       $node = $doc->getElementsByTagName ("base");
       $len = $node->getLength;
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Download source base: </td><td colspan=2 class=$my_subs::odd><input type=text name='base_href" . $len . "' size=40 value=''></td></tr>\n";

       $node = $doc->getElementsByTagName ("file");
       $len = $node->getLength;
print "<tr><td colspan=3 class='subhd2' align=center>File</td>\n";
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Title: </td><td colspan=2 class=$my_subs::odd><input type=text name='file_title" . $len . "' size=40 value=''></td></tr>\n";
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Href: </td><td colspan=2 class=$my_subs::odd><input type=text name='file_href" . $len . "' size=40 value=''></td></tr>\n";
       print "<tr><td class=$my_subs::odd><img border=0 src=$env::LineGif_file_path height=1 width=3>Rename: </td><td colspan=2 class=$my_subs::odd><input type=text name='file_rename" . $len . "' size=40 value=''></td></tr>\n";
    };

 }
 else {
    print "<tr><td class='hd' colspan=2><b>This is't Anti-Leech package!</b></td></tr>\n";
 };

print <<HTML;
<tr><td  class='subhd2' align=center colspan=2>
<input type="submit" value="Submit" name="submit">
</td><td class='subhd2' align=center>
<input type="reset" value="Reset" name="reset">
</td></tr>
</table>
</td></tr></table>
</form>
</div>
HTML
# /
#  print "<p> YYY <p>";
 $doc->dispose;
#  print "<p> YYY <p>";
})
{
print <<HTML;
<tr><td  class='odd' align=center colspan=3><img border=0 src=$env::LineGif_file_path height=1 width=3>
There is not well formated XML file
<img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>
</table>
</td></tr></table>
</div>

HTML

}
}

