#!/usr/bin/perl -w
#use Time::Object;
#use Time::Seconds;
use sdep;

require "env.pl";
require "stats_count.pm";
require "stats_total.pm";

return "OK";
sub collect_account_act
{
   my $current = $_[0];
   my $ness_date=$_[1];
   my $n_d=$ness_date;
   my $total=0;
   my $complete=0;
   my $loaded=0;
   my $flag=0;
   my @buffer;
   my @res;
   my ($date,$p_name,$f_name,$tot,$comp,$b_summa);   			
   my ($b_sum,$tail);   
   open FILE, "<$env::statlog" or die "Can't open statlog: $!\n";
   binmode(FILE);
   flock(FILE,1);
   while(<FILE>) 
   {
	if(/^$n_d\t/)
	{
            ($date,$p_name,$f_name,$tot,$comp,$b_summa)=split(/\t/,$_);
	    ($b_sum,$tail)=split(/\n/,$b_summa);
            $total=$total+$tot;
	    $loaded=$loaded+($b_sum || 0); 
	    $complete=$complete+$comp;
	}
	else
	{
             if(($total!=0)||($loaded!=0)||($complete!=0))
	     {
               push(@buffer,"$n_d\t$total\t$complete\t$loaded");
             } 
             ($date,$p_name,$f_name,$tot,$comp,$b_sum)=split(/\t/,$_);
                $total=0;
        	$loaded=0; 
	        $complete=0;
	     if($current le $date)
	     {
	        last ;
	     }	            
	
	     if(!($date le $n_d))
	     {
	        $n_d=$date;
                $total=$tot || 0;
	        $loaded=$b_sum ||0; 
	        $complete=$comp ||0;

	     } 	
	}
	$flag++;
    }
    close FILE;
    if($flag==0)
    {
      push(@buffer,"-1");
    }
    if(($total!=0)||($loaded!=0)||($complete!=0))
    {
         push(@buffer,"$n_d\t$total\t$complete\t$loaded");
    }
    my $t=time();
#    my $t=gmtime();
    my $today=formate_date($t);
    if($current eq $today)
    {
         my $ac_t=ac_total();
         push(@buffer,"$today\t$ac_t");
    }    
    @res = reverse @buffer;
    return @res;
}

sub collect_package_act
{
   my $current = $_[0];
   my $ness_date=$_[1];
   my $package_name = $_[2];
   my $n_d=$ness_date;
   my $total=0;
   my $complete=0;
   my $loaded=0;
   my $flag=0;
   my @buffer;
   my @result;
   my ($date,$p_name,$f_name,$tot,$comp,$b_summa);   			
   my ($b_sum,$tail);       
   open FILE, "<$env::statlog" or die "Can't open statlog: $!\n";
   binmode(FILE);
   flock(FILE,1);
   while(<FILE>) 
   {
	if(/^$n_d\t$package_name/)
	{
            ($date,$p_name,$f_name,$tot,$comp,$b_summa)=split(/\t/,$_);   			
            ($b_sum,$tail)=split(/\n/,$b_summa);
	    $total=$total+$tot;
	    $loaded=$loaded+($b_sum||0); 
	    $complete=$complete+$comp;
	    
	}
	else
	{
             if(($total!=0)||($loaded!=0)||($complete!=0))
	     {
               push(@buffer,"$n_d\t$total\t$complete\t$loaded");
             } 
             ($date,$p_name,$f_name,$tot,$comp,$b_sum)=split(/\t/,$_);   			
             $total=0;
	     $loaded=0; 
	     $complete=0;
	     last if($current le $date);            
	
	     if(!($date le $n_d))
             {
                if($p_name eq $package_name)
	        {
	            $total=$tot;
	            $loaded=$b_sum; 
	            $complete=$comp;
	        }
	        else
	        {
	            $total=0;
	            $loaded=0; 
	            $complete=0;
	        }
	        $n_d=$date;
	     }
        }
	$flag++;    
	
    }
    close FILE;

    if($flag==0)
    {
      push(@buffer,"-1");
    }
    if(($total!=0)||($loaded!=0)||($complete!=0))
    {
               push(@buffer,"$n_d\t$total\t$complete\t$loaded");
    } 
    my $t=time();    
#    my $t=gmtime();
    my $today=formate_date($t);
    if($current eq $today)
    {
       my $ac_t=ac_total($package_name);
       push(@buffer,"$today\t$ac_t");
    }
    @result = reverse @buffer;
    return @result;
}

