#!/usr/bin/perl -w

use strict;
use CGI qw(:all);

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{"PATH_TRANSLATED"};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g;
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g;
   push (@INC, $catalog);
};
};
require "env.pl";
};
# find common environment - end

require "trigger.pm";
require "auth_chk.pm";
require "main_menu.pm";

select STDOUT;
$|=1;

#debug
#print "Content-Type: text/plain\n\n\n";
#open (STDERR, ">& STDOUT");

&main;

sub main {


        my $user_pass;
	my $auth_cookie;
	my $hash_passwd;

	my($REMOTE_USER,$REMOTE_PASSWD);

        $REMOTE_USER = param ("login");
	$REMOTE_PASSWD =  param ("passwd");

	$auth_cookie  = cookie('user') || "";

        if(!$auth_cookie)
	{
        	if((!$REMOTE_USER)||(!$REMOTE_PASSWD))
                {
                  # Incorrect authorization

                  print_auth_page();
                }
                else
                {

                  my $hash_passwd = verify_passwd($REMOTE_USER,$REMOTE_PASSWD);
                        if(!$hash_passwd)
	                {
                           # Incorrect authorization
                           print_auth_page();
		         }
                         else
                         {
                           set_cookie($REMOTE_USER);
                           print_main_page($REMOTE_USER);
		         }
	        }
       }
       else ## cookie found :)
       {
	       	my $HAD_REMOTE_USER = verify_cookie($auth_cookie);
                ## user passs undef
                if(!$HAD_REMOTE_USER)
	        {

                   my $hash_passwd;

          	   if(($REMOTE_USER)&&($REMOTE_PASSWD))
		   {
			$hash_passwd = verify_passwd($REMOTE_USER,$REMOTE_PASSWD);
		   }

          	   if($hash_passwd)
                   {
			set_cookie($REMOTE_USER);
                        print_main_page($REMOTE_USER);
                   }
                   else
		   {
                       #Incorrect authorization
                       print_auth_page();
		   }

		}
                else
                {
			set_cookie($HAD_REMOTE_USER);
		        print_main_page($HAD_REMOTE_USER);
		}
       }
}

sub print_auth_page
{

		        print header();
			print <<HEADER;
         		<html>
			<head>
                           <title>Login to AL Download Protection</title>
                           <link rel="stylesheet" type="text/css" href="$env::Css_file_path">
			</head>
			<body>

	                <table border=0 width=40% align=center valign=top cellpadding=0 cellspacing=0><tr bgcolor=#ffffff><td width=100%><table width=100% border=0 cellpadding=7 cellspacing=1>

	                <form action=admin.pl  method=post>
                        <tr>
	                  <td align=left class="odd">Login</td>
	                  <td align=left class="odd"><input type=text name="login"></td>
	                </tr>
	                <tr>
	                  <td class="odd"> Password</td>
	                  <td class="odd"><input type=password name="passwd"></td>
	                </tr>
	                <tr>
	                  <td class="odd"> <input type=submit value="Submit"></td>
                          <td align=center class="odd"> <input type=reset value="Reset"></td>
	                </tr>
	                </form>
	                </table>
	                </td>
	                </tr>
	                </table>

			</body>
			</html>

HEADER

}

sub print_main_page
{

                       my $USER = $_[0];

			print <<HTML;

			<html>
			<head>
                          <title>AL Download Protection</title>
                          <link rel="stylesheet" type="text/css" href="$env::Css_file_path">
			</head>
			<body>

HTML

            main_menu("start","./");
			print <<HTML;

			<h1 class="hd">Welcome, $USER !</h1>
                         <p>The following options are avaliable for you:</p>


                    <h2 class="hd2">TO MANAGE PACKAGES</h2>
                         &nbsp  <a href=new.pl class="mylink"> New </a>
			        <p>  &nbsp  <a href=edit.pl class="mylink"> Edit </a>
			        <p>  &nbsp  <a href=delete.pl class="mylink"> Delete </a>

                    <h2 class="hd2">TO ADD EXSISTING PACKAGES</h2>
                    <p>  &nbsp  <a href=import.pl class="mylink"> Import packages </a>

                    <h2 class="hd2">TO VIEW YOUR STATISTICS</h2>
                                <p> &nbsp   <a href=./stats/statshow.pl class="mylink"> Statistics </a>
			        <p>

                    <h2 class="hd2">TO CHANGE YOUR PASSWORD</h2>
                    <p>  &nbsp  <a href=change_pass.pl class="mylink"> Change password </a>
			        <p>

                    <h2 class="hd2">TO CHANGE PARAMETERS</h2>
                    <form class="even" action=submit_template.pl method=post enctype="multipart/form-data">
                         &nbsp;  Relpace default download template with
                    <br> &nbsp;  <input type=file size=40 name=file> <input type=submit value=Submit>
                    <p></form>
                    <p>  &nbsp;

                    <h2 class="hd2">TO VIEW ONLINE DOCUMENTATION</h2>
                    <p>  &nbsp  <a href=help.html class="mylink" target=_blank> Open help file </a>
                    <p>  &nbsp;

HTML

            main_menu("start","./");


			print "</body></html>";

}
