#!/usr/bin/perl -w
use Digest::MD5;
use MIME::Base64;
use POSIX;
use sdep;

require "env.pl";

#return "Ok";

sub create_cookie {
	my $login = $_[0];
	my $md5_passwd = get_md5_passwd($login);
        my $now = time();
	my $tm   = strftime('%Y-%m-%d %H:%M:$S' , gmtime($now));
	my $ttl  = strftime('%Y-%m-%d %H:%M:$S' , gmtime($now+360));
	my $md5_all=$login. $tm. $ttl. $md5_passwd; 

	$md5_all=Digest::MD5::md5_hex($md5_all);
	my $result="$login\t". $tm."\t". $ttl."\t".$md5_all."\n";
	return encode_base64($result);
}

sub verify_cookie {
	my $encoded = $_[0];
	my $md5_passwd;
           
        my($login,$date_c,$date_d,$md5_all)=split(/\t/,decode_base64($encoded));
        $md5_passwd=get_md5_passwd($login);
        if($md5_all eq Digest::MD5::md5_hex($login. $date_c. $date_d. $md5_passwd)."\n")
        {	    
	        my $tm   = strftime('%Y-%m-%d %H:%M:$S' , gmtime());
		if (($date_c le $tm)
			 and ($tm le $date_d)) {
			return $login;
		} 
	}
	return "";
}

sub verify_passwd{
     	my $login = $_[0];
	my $passwd = $_[1];
        my $md5_passwd =Digest::MD5::md5_hex($passwd);	
        my $user_pass;	
	        open PASS, "<$env::infile" or die "Can't open passwd: $!\n";
	        binmode(PASS);
		flock(PASS,1);
		while(<PASS>) {
			last if(/^$login\t$md5_passwd\n/);
		}
	
		$user_pass = $_;
		close PASS;
		if((!$user_pass) or (!$md5_passwd))
		{
		    return "";
		}
		else
		{
		    return $md5_passwd;
		}    

}
sub get_md5_passwd{
     	my $login = $_[0];
	my $user_pass;
	my ($REMOTE_USER,$REMOTE_PASSWD);
	my ($result,$tail);
	open PASS, "<$env::infile" or die "Can't open passwd: $!\n";
	binmode(PASS);
	flock(PASS,1);
	while(<PASS>) {
			last if(/^$login\t/);
	}
	
	$user_pass = $_;
	close PASS;
        if(!$user_pass)
        {
	    return "";
	}
	else
	{
	    ($REMOTE_USER,$REMOTE_PASSWD)=split(/\t/,$user_pass);       
	    ($result,$tail)=split(/\n/,$REMOTE_PASSWD);
	    return $result;       
         }
}

sub rewr_pass {
   my $REMOTE_USER=$_[0];
   my $NEW_PASSWD=$_[1];
   my $md5_passwd=Digest::MD5::md5_hex($NEW_PASSWD);
     
   open(F, "+< $env::infile")     or die "can't read $infile : $!";
   binmode(F);
   flock(F,2);
   my $out="";
   while (<F>){
        if(/^$REMOTE_USER\t/){
          $_ = "$REMOTE_USER\t$md5_passwd\n";
        }
        $out .=$_;
   }   
   seek(F,0,0)               or die "Seeking: $!";

   print F $out              or die "Printing: $!";
   truncate(F,tell(F))       or die "Truncating: $!";
   close(F)                  or die "Closing: $!";
   
   return $md5_passwd;
}




