#!/usr/bin/perl -w
use strict;

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{"PATH_TRANSLATED"};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g;
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g;
   push (@INC, $catalog);
};
};
require "env.pl";
};
# find common environment - end

use IO::Dir;

require "auth_chk.pm";
require "trigger.pm";

require "main_menu.pm";
require "my_subs.pm";

my  $auth_cookie=check_auth();
if($auth_cookie)
{

   print <<HTML;

   <HTML>
   <HEAD>
   <LINK REL="stylesheet" TYPE="text/css" HREF="$env::Css_file_path">
   <title>Edit package</title>
   </HEAD>
   <BODY>

HTML

   main_menu ("edit","./");


my $dir = $env::Package_base;
my $d = new IO::Dir $dir;

if (defined $d)
{

   print <<HTML;

   <form method="POST" action="submit_edit.pl">
   <div align="center">
   <table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
   <table border="0" cellspacing="0" cellpadding="0">
   <tr><td class="hd"><img border=0 src=$env::LineGif_file_path height=1 width=3>
   Select package for edit
   <img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>
HTML

   while (defined($_ = $d->read))
   {
      my $l = length ($_);

      if ($l > 4)
      {
         my $f = substr ($_, $l-4, 4);

        if ($f eq $env::extension)
        {
            my_subs::even ($my_subs::odd);
            my $name = substr ($_, 0, $l-4);
            print "<tr><td class=$my_subs::odd>\n";
            print "<input type='radio' name='del' value='$name'>\n";
            print $name."</td></tr>\n";
        }
      }
   };
   $d->rewind;

print <<HTML;
<tr><td colspan=2><div align=center class="hd">
<input type="submit" value="Continue" name="submit">
</div></td></tr>
</table>
</td></tr></table>
</div>
</form>
HTML

}
else {

   print <<HTML;

   <div align="center">
   <table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
   <table border="0" cellspacing="0" cellpadding="0">
   <tr><td class="hd"><img border=0 src=$env::LineGif_file_path height=1 width=3>
   You have not permission for edit
   <img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr>
   </table>
   </td></tr></table>
   </div>

HTML

};

main_menu ("edit", "./");

print <<HTML;
</BODY>
</HTML>
HTML

# $doc->dispose;

} # auth_cookie
