#!/usr/bin/perl -w
use strict;
use CGI qw(:all);

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{"PATH_TRANSLATED"};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g;
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g;
   push (@INC, $catalog);
};
};
require "env.pl";
};
# find common environment - end

require "auth_chk.pm";
#require "count_stats.pm";
require "stats_count.pm";
require "trigger.pm";
require "main_menu.pm";
select STDOUT;
$|=1;
&main;

sub main {
        my @pack_buffer      ;
        my $item;

	my $new_cookie = check_auth();

	if($new_cookie)
	{
			print <<HTML1;
			
<html>
                        <head>
			<link rel="stylesheet" type="text/css" href="$env::Css_file_path">
                        <title>Staistics home</title>
                        </head>
                        <body>
HTML1
                        main_menu("statistics","../");
                        print <<HTML;			
                        <p>Your account home is: $env::account</p>
                        <p>See your account stats here:
                        <ul>
                        <li><a href="rawlog.pl" class="mylink">raw access log today</a></li>
                        <li><a href="account_daily_statistics.pl" class="mylink">your account today</a></li>
                        <li><a href="account_activity_statistics.pl" class="mylink">account activity statistics</a></li>
                        <li>your account statistics by packages<br>
                        <div align="center"><center><table border="1" cellpadding="0" cellspacing="0" width="100%">
                        <tr>
                           <td width="33%">Package</td>
                           <td width="33%">Today</td>
                           <td width="34%">Activity</td>
                        </tr>
HTML
@pack_buffer=get_package();
foreach $item(@pack_buffer)
{
   print "<tr>";
   print td({ width=>"33%"},"$item");
   print td(
             { width=>"33%"},
	     a({-class => 'mylink',href=>"package_daily_statistics.pl?pack=$item"},"Today")
	   );
   print td(
             { width=>"33%"},
	     a({-class => 'mylink',href=>"package_activity_statistics.pl?pack=$item"},"Activity")
	   );
   print "</tr>";

}
   print "<tr>";
   print td({ width=>"33%"},"Unknown");
   print td(
             { width=>"33%"},
	     a({-class => 'mylink',href=>"package_daily_statistics.pl?pack=Unknown"},"Today")
	   );
   print td(
             { width=>"33%"},
	     a({-class => 'mylink',href=>"package_activity_statistics.pl?pack=Unknown"},
	       "Activity")
	   );
   print "</tr>";

print <<HTML1;
                        </table>
                        </center></div></li>
                        </ul>

                        <p>To see previous stats, select 'Today' and follow links for prevois stats at the bottom
                         of the page.</p>
<!--			<a href=../admin.pl class="mylink"> BACK TO THE MAIN PAGE... </a>
-->
HTML1
                        main_menu("statistics","../");
                        print "</body></html>";
	   }
}

