#!/usr/bin/perl -w
use strict;

use CGI;
use POSIX;
use File::Copy;

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{"PATH_TRANSLATED"};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g;
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g;
   push (@INC, $catalog);
};
};
require "env.pl";
};
# find common environment - end

use IO::Dir;
require "auth_chk.pm";
require "trigger.pm";

require "my_subs.pm";
require "main_menu.pm";

my  $auth_cookie=check_auth();
if($auth_cookie)
{

my $query = new CGI;

my $fileExist = 0;

print <<HTML;

<HTML>
<HEAD>
<title>Edit package</title>
<LINK REL="stylesheet" TYPE="text/css" HREF="$env::Css_file_path">
</HEAD>
<BODY>
HTML

my $fileName = $query->param("del");
my $restore  = $query->param("restore");

main_menu ("edit", "./");

if ($fileName ne "") {

   if ( $restore ne '') {
      #restore backup copy
      my $path = $env::Package_base.$env::Path_Delim.$fileName.$env::extension;
      my $path_bak = $env::Backup_base.$env::Path_Delim.$fileName.$env::extension;
      if ( -f $path_bak ) {
        File::Copy::copy($path_bak, $path);
        if ( $env::System_type eq 'unix') {
            chmod $env::File_mode, $path;
        }
        my_subs::update_db($fileName);
      }
   }

   my_subs::edit_dom ($fileName);
   main_menu ("edit", "./");
}
else {

print <<HTML;

<div align="center">
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<tr><td class='hd'><img border=0 src=$env::LineGif_file_path height=1 width=3>
You didn't select package
<img border=0 src=$env::LineGif_file_path height=1 width=3></td></tr></table>
</td></tr></table>
</div>
HTML

   main_menu ("edit", "./");

}

print <<HTML;
</BODY>
</HTML>

HTML

} # auth cookie
